﻿using System;
using System.Reflection;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

using System.Data;
using System.Data.SqlClient;
using System.Net;
using System.IO;
using System.Threading;
using System.Text;
using System.Text.RegularExpressions;
using System.Configuration;
using fingertec;
using MySql.Data.MySqlClient;

namespace webster_demo
{
    public partial class demo : System.Web.UI.Page
    {
        MySqlConnection conn = new MySqlConnection(ConfigurationManager.ConnectionStrings["webster_mysql"].ConnectionString);

        protected void Page_Load(object sender, EventArgs e)
        {
            Label2.Text = AssemblyName.GetAssemblyName("\\bin\\fingertec.dll").Version.ToString();
        }

        protected void Check_Click(object sender, EventArgs e)
        {
            bool status;
            webster.db_delete_fptemplate(conn, serialno.Text);
            webster.db_delete_user(conn, serialno.Text);
            webster.db_delete_log(conn, serialno.Text);
            status = webster.check_terminal_log_user(conn, serialno.Text);
            Label1.Text = status.ToString();
            Label1.Text = webster.return_recordid.ToString();
        }

        protected void GetInfo_Click(object sender, EventArgs e)
        {
            bool status;
            status = webster.check_terminal_info(conn, serialno.Text);
            Label1.Text = status.ToString();
        }

        protected void clearlog_Click(object sender, EventArgs e)
        {
            bool status;
            status = webster.clear_terminal_log(conn, serialno.Text);
            Label1.Text = status.ToString();
        }

        protected void ClearData_Click(object sender, EventArgs e)
        {
            bool status;
            status = webster.clear_terminal_all(conn, serialno.Text);
            Label1.Text = status.ToString();
        }

        protected void upload_user_Click(object sender, EventArgs e)
        {
            bool status;
            int cardno, privilege, userid;
            
            int.TryParse(u_cardno.Text, out cardno);
            int.TryParse(u_privilege.Text, out privilege);
            int.TryParse(u_userid.Text, out userid);

            status = webster.upload_user_one(conn, serialno.Text, userid, u_name.Text, privilege, u_password.Text, cardno, 0, "0000000000");
            Label1.Text = status.ToString();
        }

        protected void Upload_Template_Click(object sender, EventArgs e)
        {
            bool status;
            int userid, fingerid, valid;

            int.TryParse(t_userid.Text, out userid);
            int.TryParse(t_fingerid.Text, out fingerid);
            int.TryParse(t_valid.Text, out valid);

            status = webster.upload_fptemplate_one(conn, serialno.Text, userid, t_template.Text, fingerid, valid);
            Label1.Text = status.ToString();

        }

        protected void delete_user_Click(object sender, EventArgs e)
        {
            bool status;
            int userid;

            int.TryParse(u_userid.Text, out userid);

            status = webster.delete_user_one(conn, serialno.Text, userid);
            Label1.Text = status.ToString();
        }

        protected void delete_template_Click(object sender, EventArgs e)
        {
            bool status;
            int userid, fingerid;

            int.TryParse(t_userid.Text, out userid);
            int.TryParse(t_fingerid.Text, out fingerid);

            status = webster.delete_fptemplate_one(conn, serialno.Text, userid, fingerid);
            Label1.Text = status.ToString();
        }

        protected void reload_option_Click(object sender, EventArgs e)
        {
            bool status;
            status = webster.reload_terminal_setting(conn, serialno.Text);
            Label1.Text = status.ToString();
        }

        protected void reboot_Click(object sender, EventArgs e)
        {
            bool status;
            status = webster.reboot_terminal(conn, serialno.Text);
            Label1.Text = status.ToString();
        }

        protected void all_user_Click(object sender, EventArgs e)
        {
            Session["view_type"] = "user";


            string query = "SELECT userid,name, password, cardnumber, privilege, created_time  FROM webster_userinfo where serialno=" + serialno.Text + "";
            MySqlDataAdapter dAdapter = new MySqlDataAdapter(query, conn);
            MySqlCommandBuilder cBuilder = new MySqlCommandBuilder(dAdapter);

            DataTable dTable = new DataTable();
            dAdapter.Fill(dTable);

            DataView myDataView = new DataView(dTable);

            GridView1.DataSource = myDataView;
            GridView1.AllowPaging = true;
            GridView1.PageSize = 10;
            GridView1.DataBind();
        }

        protected void all_template_Click(object sender, EventArgs e)
        {
            Session["view_type"] = "template";


            string query = "SELECT userid, template,fingerid,valid,created_time FROM webster_usertemplate where serialno=" + serialno.Text + "";
            MySqlDataAdapter dAdapter = new MySqlDataAdapter(query, conn);
            MySqlCommandBuilder cBuilder = new MySqlCommandBuilder(dAdapter);

            DataTable dTable = new DataTable();
            dAdapter.Fill(dTable);

            DataView myDataView = new DataView(dTable);

            GridView1.DataSource = myDataView;
            GridView1.AllowPaging = true;
            GridView1.PageSize = 10;
            GridView1.DataBind();
        }

        protected void all_option_Click(object sender, EventArgs e)
        {

            string query = "SELECT serialno, lastactivity, created_time, fwversion,fpcount,transactioncount,usercount, devicename, algver, ipaddress FROM webster_terminal where serialno=" + serialno.Text + "";
            MySqlDataAdapter dAdapter = new MySqlDataAdapter(query, conn);
            MySqlCommandBuilder cBuilder = new MySqlCommandBuilder(dAdapter);
            DataTable dTable = new DataTable();
            dAdapter.Fill(dTable);

            DataView myDataView = new DataView(dTable);

            GridView1.DataSource = myDataView;
            GridView1.DataBind();
        }

        protected void udp_request_Click(object sender, EventArgs e)
        {
            bool status;
            status = webster.trigger_terminal(conn, serialno.Text);
            Label1.Text = status.ToString();
        }

        protected void all_transaction_log_Click(object sender, EventArgs e)
        {
            Session["view_type"] = "transaction";

            string query = "SELECT userid, checktime, checktype, verifycode from webster_checkinout where serialno=" + serialno.Text + "";
            MySqlDataAdapter dAdapter = new MySqlDataAdapter(query, conn);
            MySqlCommandBuilder cBuilder = new MySqlCommandBuilder(dAdapter);
            DataTable dTable = new DataTable();
            dAdapter.Fill(dTable);

            DataView myDataView = new DataView(dTable);
            GridView1.DataSource = myDataView;
            GridView1.AllowPaging = true;
            GridView1.PageSize = 10;
            GridView1.DataBind();
        }

        protected void GridView1_PageIndexChanging(object sender, GridViewPageEventArgs e)
        {
            string query = "";

            if ((String)Session["view_type"] == "transaction")
                query = "SELECT userid, checktime, checktype, verifycode from webster_checkinout where serialno=" + serialno.Text + "";
            else if ((String)Session["view_type"] == "template")
                query = "SELECT userid, template,fingerid,valid,created_time FROM webster_usertemplate where serialno=" + serialno.Text + "";
            else if ((String)Session["view_type"] == "template_10")
                query = "SELECT userid, template,fingerid,valid,created_time FROM webster_usertemplate_fp10 where serialno=" + serialno.Text + "";
            else if ((String)Session["view_type"] == "user")
                query = "SELECT userid,name, password, cardnumber, privilege, created_time  FROM webster_userinfo where serialno=" + serialno.Text + "";
            else if ((String)Session["view_type"] == "op_log")
                query = "SELECT * FROM webster_oplog where serialno=" + serialno.Text + "";

            MySqlDataAdapter dAdapter = new MySqlDataAdapter(query, conn);
            MySqlCommandBuilder cBuilder = new MySqlCommandBuilder(dAdapter);

            DataTable dTable = new DataTable();
            dAdapter.Fill(dTable);

            DataView myDataView = new DataView(dTable);

            GridView1.PageIndex = e.NewPageIndex;
            GridView1.DataSource = myDataView;
            GridView1.AllowPaging = true;
            GridView1.PageSize = 10;

            GridView1.DataBind();
        }

        protected void all_op_log_Click(object sender, EventArgs e)
        {
            Session["view_type"] = "op_log";

            //create the database query
            string query = "SELECT * from webster_oplog where serialno=" + serialno.Text + "";
            MySqlDataAdapter dAdapter = new MySqlDataAdapter(query, conn);
            MySqlCommandBuilder cBuilder = new MySqlCommandBuilder(dAdapter);
            //create a DataTable to hold the query results
            DataTable dTable = new DataTable();
            dAdapter.Fill(dTable);

            DataView myDataView = new DataView(dTable);
            GridView1.DataSource = myDataView;
            GridView1.AllowPaging = true;
            GridView1.PageSize = 10;
            GridView1.DataBind();
        }

        protected void all_template_fp10_Click(object sender, EventArgs e)
        {
            Session["view_type"] = "template_10";

            //create the database query
            string query = "SELECT userid, template,fingerid,valid,created_time FROM webster_usertemplate_fp10 where serialno=" + serialno.Text + "";
            MySqlDataAdapter dAdapter = new MySqlDataAdapter(query, conn);
            MySqlCommandBuilder cBuilder = new MySqlCommandBuilder(dAdapter);
            //create a DataTable to hold the query results
            DataTable dTable = new DataTable();
            dAdapter.Fill(dTable);

            DataView myDataView = new DataView(dTable);
            GridView1.DataSource = myDataView;
            GridView1.AllowPaging = true;
            GridView1.PageSize = 10;
            GridView1.DataBind();
        }

    }
}